require 'thor'

require 'gradesfirst/cli_helper'
require 'gradesfirst/command'
require 'gradesfirst/branch_command'
require 'gradesfirst/code_talk_command'
require 'gradesfirst/commit_message_command'
require 'gradesfirst/pair_command'
require 'gradesfirst/task_cli'

require 'pivotal_tracker'

module GradesFirst
  class CLI < Thor
    include GradesFirst::CliHelper

    desc 'branch', GradesFirst::BranchCommand.description
    def branch
      set_pivotal_tracker_api_token
      execute GradesFirst::BranchCommand
    end

    desc 'codetalk', GradesFirst::CodeTalkCommand.description
    long_desc GradesFirst::CodeTalkCommand.long_description
    def codetalk
      execute GradesFirst::CodeTalkCommand
    end

    desc 'commit-message', GradesFirst::CommitMessageCommand.description
    def commit_message
      set_pivotal_tracker_api_token
      execute GradesFirst::CommitMessageCommand
    end

    desc 'pair', GradesFirst::PairCommand.description
    long_desc GradesFirst::PairCommand.long_description
    def pair
      execute GradesFirst::PairCommand
    end

    desc 'task COMMAND', 'Manage tasks related to a PivotalTracker story.'
    subcommand 'task', GradesFirst::TaskCLI

    Signal.trap('SIGINT') do
      print "\n"
      exit 1
    end

  end
end
