require 'gradesfirst/cli_helper'
require 'gradesfirst/task_add_command'
require 'gradesfirst/task_delete_command'
require 'gradesfirst/task_list_command'
require 'gradesfirst/task_move_command'
require 'gradesfirst/task_toggle_command'

module GradesFirst
  class TaskCLI < Thor
    include GradesFirst::CliHelper

    namespace :task
    # Waiting on fix for subcommands with default command.
    # https://github.com/erikhuda/thor/pull/374
    #default_command :list

    desc 'add DESCRIPTION', GradesFirst::TaskAddCommand.description
    def add(description)
      set_pivotal_tracker_api_token
      execute(GradesFirst::TaskAddCommand, description)
    end

    desc 'delete POSITION', GradesFirst::TaskDeleteCommand.description
    def delete(position)
      set_pivotal_tracker_api_token
      execute(GradesFirst::TaskDeleteCommand, position)
    end

    desc 'list', GradesFirst::TaskListCommand.description
    def list
      set_pivotal_tracker_api_token
      execute(GradesFirst::TaskListCommand)
    end

    desc 'move FROM TO', GradesFirst::TaskMoveCommand.description
    def move(from, to)
      set_pivotal_tracker_api_token
      execute(GradesFirst::TaskMoveCommand, from , to)
    end

    desc 'toggle POSITION', GradesFirst::TaskToggleCommand.description
    def toggle(position)
      set_pivotal_tracker_api_token
      execute(GradesFirst::TaskToggleCommand, position)
    end

  end
end
